//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}
void print (int elem)
{
  cout << elem << ' ';
}

int square (int value)
{
  return value*value;
}

int main(int argc, char* argv[])
{
  std::set<int> coll1;
  std::vector<int> coll2;

  //      1  9  coll1
  for (int i=1; i<=9; ++i) {
    coll1.insert(i);
  }

  PRINT_ELEMENTS(coll1, ":\n");
  //       colll  col12
  // - square transformed values
  std::transform (coll1.begin(),coll1.end(), // 
    std::back_inserter(coll2), // 
    square);  // 
  PRINT_ELEMENTS(coll2,":\n");

  getch();
  return 0;
}
//---------------------------------------------------------------------------
